package cz.cuni.amis.pogamut.emohawk.examples.emoticonposhbot_b;

import SteeringProperties.LeaderFollowingProperties;
import SteeringProperties.PathFollowingProperties;
import SteeringProperties.TargetApproachingProperties;
import cz.cuni.amis.pogamut.base3d.worldview.object.Location;
import cz.cuni.amis.pogamut.sposh.context.EmohawkContext;
import cz.cuni.amis.pogamut.sposh.engine.VariableContext;
import cz.cuni.amis.pogamut.sposh.executor.PrimitiveInfo;
import cz.cuni.amis.pogamut.sposh.executor.StateAction;
import cz.cuni.amis.pogamut.ut2004.communication.messages.ItemType;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbinfomessages.Item;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbinfomessages.Player;
import java.util.logging.Level;
import static cz.cuni.amis.pogamut.emohawk.examples.emoticonposhbot_b.Informations.*;
import cz.cuni.amis.pogamut.sposh.executor.ActionResult;

/**
 * Action that causes bot to jump.
 *
 * @author Honza
 */
@PrimitiveInfo(name = "navigateToPlayer", description = "navigate to player.")
public class NavigateToPlayer extends StateAction<EmohawkContext> {

    public NavigateToPlayer(EmohawkContext ctx) {
        super("navigaToPlayer", ctx);
    }

    @Override
    public void init(VariableContext params) {
        ctx.getLog().setLevel(Level.INFO);
        ctx.getNavigation().stopNavigation();
    }

    @Override
    public ActionResult run(VariableContext params) {
        Player p = ctx.getPlayers().getNearestVisiblePlayer();
        ctx.getComm().sendGlobalBubbleMessage("Vidim te", 1);
        ctx.getNavigation().navigate(p);
        return ActionResult.RUNNING;
    }

    @Override
    public void done(VariableContext params) {
        ctx.getSteering().removeTargetApproachingSteering();
    }
}
