package cz.cuni.amis.pogamut.emohawk.examples.emoticonposhbot_b;

import cz.cuni.amis.pogamut.sposh.context.EmohawkContext;
import cz.cuni.amis.pogamut.sposh.engine.VariableContext;
import cz.cuni.amis.pogamut.sposh.executor.PrimitiveInfo;
import cz.cuni.amis.pogamut.sposh.executor.StateSense;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbinfomessages.Player;
import java.util.logging.Level;

/**
 * Sense for seeing another players.
 * @author Honza
 */
@PrimitiveInfo(name = "nearPlayer", description = "The bot is very close to another player")
public class NearPlayer extends StateSense<EmohawkContext, Boolean> {

    public NearPlayer(EmohawkContext ctx) {
        super("nearPlayer", ctx);
        ctx.getLog().setLevel(Level.INFO);
    }

    @Override
    public Boolean query(VariableContext params) {
        Player p = ctx.getPlayers().getRandomVisiblePlayer();
        if (p == null) return false;
        double distance = ctx.getInfo().getDistance(p);
        return (distance < 300);
    }
}
