package cz.cuni.amis.pogamut.emohawk.examples.emoticonposhbot_b;

import cz.cuni.amis.pogamut.sposh.context.EmohawkContext;
import cz.cuni.amis.pogamut.sposh.engine.VariableContext;
import cz.cuni.amis.pogamut.sposh.executor.PrimitiveInfo;
import cz.cuni.amis.pogamut.sposh.executor.StateAction;
import cz.cuni.amis.pogamut.ut2004.communication.messages.ItemType;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbinfomessages.Item;
import java.util.Random;
import static cz.cuni.amis.pogamut.emohawk.examples.emoticonposhbot_b.Informations.*;
import cz.cuni.amis.pogamut.sposh.executor.ActionResult;
import java.util.logging.Level;

/**
 * Action that causes bot to jump.
 *
 * @author Honza
 */
@PrimitiveInfo(name = "tryStartCommunication", description = "Try to start the communication.")
public class TryStartCommunication extends StateAction<EmohawkContext> {

    Random rnd = null;

    public TryStartCommunication(EmohawkContext ctx) {
        super("tryStartCommunication", ctx);
        ctx.getLog().setLevel(Level.INFO);
    }

    @Override
    public void init(VariableContext params) {
        rnd = new Random();
        if (ctx.getNavigation().isNavigating()) ctx.getNavigation().stopNavigation();
        if (!ctx.getPlayers().canSeePlayers()) 
            ctx.getMove().turnHorizontal(20);
        else
            ctx.getMove().turnTo(ctx.getPlayers().getRandomVisiblePlayer());
    }

    @Override
    public ActionResult run(VariableContext params) {
        int x = rnd.nextInt(10);
        if (x < 1) {
            Informations.index = 0;
            ctx.getEmoticons().setEmoticon(ems[index], 2);
            myTurn = false;
            isCommunication = true;
        }
        return ActionResult.RUNNING_ONCE;
    }

    @Override
    public void done(VariableContext params) {
    }
}
